--dtree.ex

include klrlfn.e

constant
  Fvoid = { ' ', ' ', ' ' },
  Fline = { 179, ' ', ' ' },
  Ftee  = { 195, 196, 196 },
  Fell  = { 192, 196, 196 }

sequence help, stack, foliage, cmd, path
  help={
    "usage:  ex dtree [/?] [path]   --shows subdirectory structure\n",
    "  based on tree.c for Micro-C by Dave Dunfield\n",
    "  find Dave at http://www.dunfield.com/devtools.htm\n"  }
  stack={}
  foliage={}

integer stackptr, level
  stackptr=1
  level=1

function lowcase(sequence x)
  return x+(x>='A' and x<='Z')*32
  end function

function icompare(sequence a, sequence b)
  sequence ta, tb
  ta=lowcase(a)
  tb=lowcase(b)
  return compare(ta,tb)
  end function

procedure sortstack(integer n1, integer n2)
  integer i
  sequence t
  for j=(n1+1) to n2 do
    t=stack[j]
    i=j-1
    while (i>=n1) and (icompare(stack[i],t)>0) do
      stack[i+1]=stack[i]
      i -= 1
      end while
    stack[i+1]=t
    end for
  end procedure

function choice(integer x, sequence t, sequence f)
  if x then return t else return f end if
  end function

procedure dtree()
  integer plength, dirbase
  sequence found
  dirbase = stackptr
  plength=length(path)
  path=path & "*.*"
  found=lfnfindfirst(path)
  while length(found[1]) do
    if and_bits(found[2],lfnDIREC) and not
      and_bits(found[2],lfnHIDDEN) and not
      (found[1][1]='.') then
      stack=append(stack,found[1])
      stackptr += 1
      end if
    found=lfnfindnext()
    end while
  lfnfindclose()
  if length(foliage)<level then foliage=append(foliage,{}) end if
  foliage[level]=choice((stackptr>dirbase),Fvoid,Fline)
  if stackptr=dirbase then   --no subdirectories
    if level=1 then puts(1,"no subdirectories found\n") end if
    return
    end if
  sortstack(dirbase,stackptr-1)
  level += 1
  for i=dirbase to stackptr-1 do
    foliage[level-1]=choice((i<(stackptr-1)),Ftee,Fell)
    for j=1 to (level-1) do puts(1,foliage[j]) end for
    foliage[level-1]=choice((i<(stackptr-1)),Fline,Fvoid)
    puts(1,stack[i] & "\n")
    path=path[1..plength] & stack[i] & "\\"
    dtree()   --recursion
    end for
  path=path[1..plength]
  stackptr=dirbase
  stack=stack[1..(dirbase-1)]
  level -= 1
  end procedure


--main
  cmd=command_line()
  if length(cmd)<3 then path=lfngetcwd() else path=cmd[3] end if
  if compare(path,"/?")=0 then
    for i=1 to length(help) do puts(1,help[i]) end for
    abort(0)
    end if
  puts(1,path & "\n")
  if path[length(path)]!='\\' then path=path & "\\" end if
  dtree()
  --end main
