--ed.ex
--text editor, K.L. Roger
--this version is for Euphoria 2.0 dos32
--it replaces tabs with spaces and divides lines longer than maxcols

include conio.e
include klrlfn.e

constant
  maxlines=12000,
  screenrows=25,
  screencols=80,
  tabs=4,
  maxcols=screencols-1,
  page=screenrows-5,
  true=1,
  false=0,
  nonolist={".exe",".com",".dll",".sys",".lib",".zip"}

sequence
  doc, cmdline, curline, capline, fname, srchstr,
  str0, str1, str2

integer
  frow, srow, col, nrowf, lenss,
  blkbeg, blkend,
  incok, savok, cpyok, indtog,
  zz, f1

constant hlp={
  " CR    insert line below cursor",
  " BS    delete character to left",
  " Del   delete character",
  "^LArr  to beginning of line",
  "^RArr  to end of line",
  " Home  to top of screen",
  " End   to bottom of screen",
  "^Home  to beginning of file",
  "^End   to end of file",
  " PgUp  up 20 lines",
  " PgDn  down 20 lines",
  "",
  "^fs    file save and continue",
  "^fe    file save and exit ed",
  "^fq    file quit (or ^c or Esc)",
  "^fg    file get and insert",
  "",
  "^ff    insert formfeed at cursor",
  "^ll    line locate by line number",
  "^li    line insert above (or ^n)",
  "^lx    line delete/capture (or ^y)",
  "^lc    line capture w/o deleting",
  "^lu    line uncapture",
  "^ls    line split at cursor",
  "^lj    line join to line above",
  "^la    line autoindent toggle",
  "",
  "^ss    string say and locate",
  "^sa    string locate again",
  "",
  "^bb    block beginning line set",
  "^be    block ending line set",
  "^bc    block copy",
  "^bm    block move",
  "^bx    block delete",
  "^bs    block save as a new file" }

function lower(object x)
  return x+(x>='A' and x<='Z')*#20
  end function

--prep
cmdline=command_line()
if length(cmdline)<3 then
  puts(1,"usage:  ex ed filename   --text editor, F1 is the help key\n")
  abort(0)
  end if
fname=cmdline[3]
zz=length(fname)
if zz>3 then
  for i=1 to length(nonolist) do
    if compare(lower(fname[zz-3..zz]),nonolist[i])=0 then
      printf(1,"can't edit %s files\n",{nonolist[i]})
      abort(0)
      end if
    end for
  end if
--end prep

procedure str2doc(sequence s, integer row)
  --copy string s to doc[row]
  --delete trailing spaces
  integer n
  n=length(s)
  for i=n to 1 by (-1) do
    if s[i]=' ' then n=n-1 else exit end if
    end for
  if n then s=s[1..n] else s="" end if
  doc[row]=s
  end procedure

procedure nuldoc(integer row)
  doc[row]=""
  end procedure

procedure set_init()
  indtog=true
  blkbeg=0
  blkend=0
  doc={}
  nrowf=0
  frow=0
  curline=""
  capline=""
  srchstr=""
  lenss=0
  clrscr()
  srow=1
  col=1
  end procedure

procedure nul_lin()
  gotoxy(1,srow)
  clreol()
  end procedure

function querystr(sequence qs)
  sequence as
  nul_lin()
  as=query(qs)
  nul_lin()
  puts(1,curline)
  gotoxy(col,srow)
  return as
  end function

function querychar(sequence qs)
  integer ac, ax
  nul_lin()
  puts(1,qs&" ? ")
  gotoxy(length(qs)+4,srow)
  ac=getch()
  if ac=0 then ax=getch() end if
  nul_lin()
  puts(1,curline)
  gotoxy(col,srow)
  return ac
  end function

procedure wrt_pag(integer r1)
  integer j
  clrscr()
  j=r1
  for i=1 to screenrows do
    if j>nrowf then exit end if
    gotoxy(1,i)
    str0=doc[j]
    puts(1,str0)
    j=j+1
    end for
  end procedure

procedure inc_nrow()
  if nrowf=maxlines then
    incok=false
    zz=querychar(sprintf("%d line limit reached, ok",{maxlines}))
  else
    incok=true
    nrowf=nrowf+1
    doc=append(doc,"")
    end if
  end procedure

procedure dec_nrow()
  if frow=nrowf then
    nul_lin()
    curline=""
    col=1
    nuldoc(frow)
  else
    nrowf=nrowf-1
    for i=frow to nrowf do doc[i]=doc[i+1] end for
    doc=doc[1..nrowf]
    curline=doc[frow]
    if blkbeg>frow then blkbeg=blkbeg-1 end if
    if blkend>=frow then blkend=blkend-1 end if
    end if
  end procedure

procedure uh_oh(sequence name)
  zz=querychar(sprintf("cannot write file %s, ok",{name}))
  nul_lin()
  puts(1,curline)
  gotoxy(col,srow)
  savok=false
  end procedure

procedure doexit()
  restore_screen()
  abort(0)
  end procedure

procedure edabort()
  zz=querychar("quit without saving")
  if (zz='y') or (zz='Y') then doexit() end if
  end procedure

procedure crs_up()
  if frow=1 then return end if
  str2doc(curline,frow)
  srow=srow-1
  frow=frow-1
  curline=doc[frow]
  if srow=0 then
    srow=1
    gotoxy(1,1)
    insline()
    puts(1,curline)
    end if
  gotoxy(col,srow)
  end procedure

procedure crs_dwn()
  str2doc(curline,frow)
  if frow=nrowf then
    inc_nrow()
    if not incok then return end if
    end if
  srow=srow+1
  frow=frow+1
  curline=doc[frow]
  if srow>screenrows then
    puts(1,"\n")  --???
    gotoxy(1,screenrows)
    puts(1,curline)
    srow=screenrows
    end if
  gotoxy(col,srow)
  end procedure

procedure crs_bol()
  col=1
  if indtog then
    for i=1 to length(curline) do
      col=i
      if curline[i]!=' ' then exit end if
      end for
    end if
  gotoxy(col,srow)
  end procedure

procedure crs_eol()
  col=length(curline)+1
  if col>maxcols then col=maxcols end if
  gotoxy(col,srow)
  end procedure

procedure get_fil(integer f)
  integer  n, k, m, cc, insert
  sequence cstr
  object tstr
  if nrowf=0 then insert=0 else insert=1 end if
  while true do
    tstr=gets(f)
    if atom(tstr) then exit end if --eof
    --remove '\n'
    n=length(tstr)
    if n then
      if tstr[n]='\n' then
        n=n-1
        tstr=tstr[1..n]
        end if
      end if
    --expand tabs
    k=0
    cstr=""
    for i=1 to n do
      cc=tstr[i]
      if cc='\t' then
        m=tabs-remainder(k,tabs)
        if m then
          for j=1 to m do cstr=cstr&' ' k=k+1 end for
          end if
        else cstr=cstr&cc k=k+1
        end if
      end for
    n=k
    --chop long lines to maxcols
    while true do
      inc_nrow()
      if not incok then return end if
      if insert then
        for j=nrowf to (frow+1) by (-1) do doc[j]=doc[j-1] end for
        end if
      if not insert then frow=frow+1 end if
      if n>maxcols then
        doc[frow]=cstr[1..maxcols]
        cstr=cstr[(maxcols+1)..n]
        else doc[frow]=cstr
        end if
      n=n-maxcols
      if insert then frow=frow+1 end if
      if n<=0 then exit end if
      end while
    end while
  end procedure

procedure put_fil(integer f, integer r1, integer r2)
  for i=r1 to r2 do puts(f,doc[i]&'\n') end for
  end procedure

procedure read_fil()
  f1=lfnopen(fname,"r")
  if f1>0 then get_fil(f1) close(f1) end if
  if nrowf=0 then nrowf=1 doc=append(doc,"") end if
  frow=1
  srow=1
  col=1
  curline=doc[1]
  wrt_pag(1)
  gotoxy(1,1)
  end procedure

procedure doopen()
  save_screen()
  set_init()
  read_fil()
  end procedure

procedure sav_fil()
  integer n
  str2doc(curline,frow)
  savok=true
  f1=lfnopen(fname,"w")
  if f1<0 then uh_oh(fname) return end if
  --remove trailing null lines
  for k=nrowf to 1 by (-1) do
    n=k
    if length(doc[n])>0 then exit end if
    end for
  put_fil(f1,1,n)
  close(f1)
  end procedure

procedure ins_lin()
  sequence j
  inc_nrow()
  if not incok then return end if
  if blkbeg>=frow then blkbeg=blkbeg+1 end if
  if blkend>=frow then blkend=blkend+1 end if
  str2doc(curline,frow)
  if frow>1 then curline=doc[frow-1] else curline="" end if
  crs_bol()
  j=doc[nrowf]
  for i=nrowf to (frow+1) by (-1) do doc[i]=doc[i-1] end for
  doc[frow]=j
  curline=""
  for i=0 to (col-1) do curline=curline&' ' end for
  gotoxy(1,srow)
  insline()
  gotoxy(col,srow)
  end procedure

procedure cap_lin()
  capline=curline
  end procedure

procedure del_lin()
  cap_lin()
  dec_nrow()
  delline()
  if (frow+screenrows-srow)<=nrowf then
    gotoxy(1,screenrows)
    puts(1,doc[frow+screenrows-srow])
    end if
  gotoxy(col,srow)
  end procedure

procedure und_lin()
  ins_lin()
  if not incok then return end if
  gotoxy(1,srow)
  curline=capline
  puts(1,curline)
  gotoxy(col,srow)
  end procedure

procedure splt_lin()
  integer n
  n=length(curline)
  if n<col then return end if
  str1=curline[1..(col-1)]
  str2=curline[col..n]
  str2doc(str1,frow)
  curline=str1
  nul_lin()
  puts(1,curline)
  crs_bol()
  crs_dwn()
  ins_lin()
  if not incok then return end if
  curline=""
  for i=1 to (col-1) do curline=curline&' ' end for
  curline=curline&str2
  str2doc(curline,frow)
  nul_lin()
  puts(1,curline)
  gotoxy(col,srow)
  end procedure

procedure join_lin()
  integer n1, n2
  if frow=1 then return end if
  n2=length(curline)
  n1=length(doc[frow-1])
  if (n1+n2)>maxcols then return end if
  str2=curline
  del_lin()
  crs_up()
  curline=curline&str2
  str2doc(curline,frow)
  nul_lin()
  puts(1,curline)
  gotoxy(col,srow)
  end procedure

procedure loc_lin()
  sequence s1
  integer n, k
  object r
  str2doc(curline,frow)
  s1=querystr("line number")
  if length(s1)=0 then return end if
  r=atoi(s1)
  if integer(r) then n=r else return end if
  if (n<1) or (n>nrowf) then return end if
  k=n-12
  if k<1 then k=1 end if
  frow=n
  srow=frow-k+1
  wrt_pag(k)
  curline=doc[frow]
  gotoxy(1,srow)
  crs_bol()
  end procedure

procedure loc_str()
  integer i, j, k, n
  if lenss=0 then return end if
  str2doc(curline,frow)
  n=length(curline)
  if col>=n then str2="" else str2=curline[(col+1)..n] end if
  j=match(srchstr,lower(str2))
  if j then j=j+col end if
  i=frow
  while (i<nrowf) and (j=0) do
    i=i+1
    str2=doc[i]
    j=match(srchstr,lower(str2))
    end while
  k=i-12
  if k<1 then k=1 end if
  frow=i
  srow=frow-k+1
  wrt_pag(k)
  curline=doc[frow]
  if j>0 then
    gotoxy(j,srow)
    col=j
   else
    gotoxy(1,srow)
    crs_eol()
    end if
  end procedure

procedure set_str()
  str2doc(curline,frow)
  srchstr=lower(querystr("string to locate"))
  lenss=length(srchstr)
  if lenss=0 then return end if
  loc_str()
  end procedure

procedure ins_chr()
  integer jj
  jj=length(curline)
  if jj=maxcols then jj=jj-1 curline=curline[1..jj] end if
  if col>(jj+1) then
    for j=(jj+1) to (col-1) do curline=curline&' ' end for
    curline=curline&zz
    puts(1,zz)
   elsif col=jj+1 then
    curline=curline&zz
    puts(1,zz)
   else
    curline=curline&' '
    for j=jj to col by (-1) do curline[j+1]=curline[j] end for
    curline[col]=zz
    puts(1,curline[col..(jj+1)])
    end if
  if col<maxcols then col=col+1 end if
  gotoxy(col,srow)
  end procedure

procedure del_crs()
  integer n
  n=length(curline)
  if col>n then return end if
  if col=n then curline=curline[1..(col-1)]
    else curline=curline[1..(col-1)]&curline[(col+1)..n]
    end if
  gotoxy(col,srow)
  puts(1,curline[col..(n-1)])
  clreol()
  gotoxy(col,srow)
  end procedure

procedure del_lft()
  if col>1 then
    col=col-1
    gotoxy(col,srow)
    del_crs()
    end if
  end procedure

procedure crs_lft()
  if col>1 then  col=col-1 gotoxy(col,srow) end if
  end procedure

procedure crs_rt()
  if col<maxcols then col=col+1 gotoxy(col,srow) end if
  end procedure

procedure crs_top()
  str2doc(curline,frow)
  frow=frow-srow+1
  srow=1
  gotoxy(col,srow)
  curline=doc[frow]
  end procedure

procedure crs_bot()
  integer j
  str2doc(curline,frow)
  j=frow
  frow=frow+screenrows-srow
  if(frow>nrowf) then frow=nrowf end if
  srow=srow+frow-j
  gotoxy(col,srow)
  curline=doc[frow]
  end procedure

procedure end_lin()
  crs_bol()
  if frow=nrowf then crs_dwn()
    else crs_dwn() ins_lin()
    end if
  end procedure

procedure page_up()
  integer k
  str2doc(curline,frow)
  k=frow+1-srow-page
  if k<1 then k=1 end if
  wrt_pag(k)
  srow=frow+1-k
  if srow>screenrows then srow=screenrows end if
  frow=k+srow-1
  curline=doc[frow]
  gotoxy(col,srow)
  end procedure

procedure page_dwn()
  integer k
  str2doc(curline,frow)
  k=frow+1-srow+page
  if k>(nrowf-4) then k=nrowf-4 end if
  if k<1 then k=1 end if
  wrt_pag(k)
  srow=frow+1-k
  if srow<1 then srow=1 end if
  frow=k+srow-1
  curline=doc[frow]
  gotoxy(col,srow)
  end procedure

procedure tab_lft()
  if col>1 then col=col-1-remainder(col-2,tabs) end if
  gotoxy(col,srow)
  end procedure

procedure tab_rt()
  if col<(maxcols-tabs) then
    col=col+tabs-remainder(col-1,tabs) end if
  gotoxy(col,srow)
  end procedure

procedure crs_tof()
  str2doc(curline,frow)
  frow=1
  srow=1
  col=1
  wrt_pag(1)
  curline=doc[frow]
  gotoxy(col,srow)
  end procedure

procedure crs_eof()
  integer i
  str2doc(curline,frow)
  if nrowf<=screenrows then i=1 srow=nrowf
    else i=nrowf-12 srow=13
    end if
  wrt_pag(i)
  frow=nrowf
  curline=doc[frow]
  gotoxy(col,srow)
  end procedure

procedure mrk_beg()
  blkbeg=frow
  end procedure

procedure mrk_end()
  blkend=frow
  end procedure

procedure cpy_blk()
  integer n, k1
  str2doc(curline,frow)
  cpyok=false
  if (blkbeg=0) or (blkbeg>blkend) then return end if
  if (frow>blkbeg) and (frow<=blkend) then return end if
  n=blkend-blkbeg+1
  for i=1 to n do
    inc_nrow()
    if not incok then return end if
    k1=frow+1
    for k=nrowf to k1 by -1 do doc[k]=doc[k-1] end for
    if blkbeg>=frow then blkbeg=blkbeg+1 blkend=blkend+1 end if
    curline=doc[blkend-i+1]
    str2doc(curline,frow)
    end for
  cpyok=true
  wrt_pag(frow-srow+1)
  gotoxy(col,srow)
  end procedure

procedure del_blk()
  integer j, k
  str2doc(curline,frow)
  if (blkbeg=0) or (blkbeg>blkend) then return end if
  j=blkbeg
  k=blkend
  blkbeg=0
  blkend=0
  frow=j
  for i=j to k do dec_nrow() end for
  if frow>5 then srow=5 else srow=1 end if
  wrt_pag(frow-srow+1)
  curline=doc[frow]
  gotoxy(col,srow)
  end procedure

procedure mov_blk()
  integer j, n
  sequence i1
  str2doc(curline,frow)
  if (blkbeg=0) or (blkbeg>blkend) then return end if
  n=blkend-blkbeg
  if frow>(blkend+1) then
    j=frow-2
    for i=blkbeg to blkend do
      i1=doc[blkbeg]
      for k=blkbeg to j do doc[k]=doc[k+1] end for
      doc[j+1]=i1
      end for
    elsif frow<blkbeg then
    j=frow+1
    for i=blkbeg to blkend do
      i1=doc[blkend]
      frow=frow+1
      for k=blkend to j by (-1) do doc[k]=doc[k-1] end for
      doc[j-1]=i1
      end for
    else return
    end if
  blkend=frow-1
  blkbeg=blkend-n
  j=frow-12
  if j<1 then j=1 end if
  srow=frow-j+1
  wrt_pag(j)
  curline=doc[frow]
  gotoxy(col,srow)
  end procedure

procedure get_blk()
  integer k, f
  str2doc(curline,frow)
  str0=querystr("filename")
  if length(str0)=0 then return end if
  f=lfnopen(str0,"r")
  if f>0 then
    get_fil(f)
    close(f)
    blkbeg=0
    blkend=0
    k=frow-12
    if k<1 then k=1 end if
    srow=frow-k+1
    wrt_pag(k)
    end if
  curline=doc[frow]
  gotoxy(col,srow)
  end procedure

procedure sav_blk()
  integer same, f
  str2doc(curline,frow)
  if (blkbeg=0) or (blkend=0) or (blkend<blkbeg) then return end if
  str2=querystr("filename")
  if length(str2)=0 then return end if
  if compare(lower(str2),lower(fname))=0 then
    same=true
    else same=false
    end if
  if(same) then
    uh_oh(str2)
    else
    f=lfnopen(str2,"w")
    if f<=0 then
      uh_oh(str2)
      else
      put_fil(f,blkbeg,blkend)
      close(f)
      end if
    end if
  end procedure

procedure help()
  str2doc(curline,frow)
  clrscr()
  printf(1,"   line %d of %d,  file:  %s\n",{frow,nrowf,fname})
  for i=1 to 18 do
    gotoxy(1,i+2)
    printf(1,"%-37s%-s",{hlp[i],hlp[i+18]})
    end for
  zz=getch() if zz=0 then zz=getch() end if
  wrt_pag(frow-srow+1)
  gotoxy(col,srow)
  end procedure

procedure block()
  zz=getch()
  if zz=#02 then mrk_beg()     --^bb
  elsif zz=#05 then mrk_end()  --^be
  elsif zz=#0D then mov_blk()  --^bm
  elsif zz=#18 then del_blk()  --^bx
  elsif zz=#03 then cpy_blk()  --^bc
  elsif zz=#13 then sav_blk()  --^bs
  end if
  end procedure

procedure files()
  zz=getch()
  if zz=#13 then sav_fil()           --^fs
  elsif zz=#11 then edabort()        --^fq
  elsif zz=#07 then get_blk()        --^fg
  elsif zz=#05 then sav_fil()        --^fe
    if savok then doexit() end if
  elsif zz=#06 then zz=#0C ins_chr() --^ff (formfeed)
  end if
  end procedure

procedure cursor()
  zz=getch()
  if zz=#4B then crs_lft()     --LArr
  elsif zz=#4D then crs_rt()   --RArr
  elsif zz=#48 then crs_up()   --UArr
  elsif zz=#50 then crs_dwn()  --DArr
  elsif zz=#53 then del_crs()  --del
  elsif zz=#73 then crs_bol()  --^LArr
  elsif zz=#74 then crs_eol()  --^RArr
  elsif zz=#47 then crs_top()  --home
  elsif zz=#4F then crs_bot()  --end
  elsif zz=#77 then crs_tof()  --^home
  elsif zz=#75 then crs_eof()  --^end
  elsif zz=#49 then page_up()  --PgUp
  elsif zz=#51 then page_dwn() --PgDn
  elsif zz=#0F then tab_lft()  --ShTab
  elsif zz=#3B then help()     --F1
  end if
  end procedure

procedure line()
  zz=getch()
  if zz=#13 then splt_lin()           --^ls
  elsif zz=#0A then join_lin()        --^lj
  elsif zz=#09 then ins_lin()         --^li
  elsif zz=#18 then del_lin()         --^lx
  elsif zz=#03 then cap_lin()         --^lc
  elsif zz=#15 then und_lin()         --^lu
  elsif zz=#0C then loc_lin()         --^ll
  elsif zz=#01 then indtog=not indtog --^la
  end if
  end procedure

procedure strings()
  zz=getch()
  if zz=#13 then set_str()    --^ss
  elsif zz=#01 then loc_str() --^sa
  end if
  end procedure

--main
  doopen()
  while(true) do
    zz=getch()
    if (zz>=32) and (zz<127) then ins_chr()
    elsif zz=#00 then cursor()
    elsif zz=#08 then del_lft()  --bs
    elsif zz=#09 then tab_rt()   --tab
    elsif zz=#0D then end_lin()  --cr
    elsif zz=#0E then ins_lin()  --^n
    elsif zz=#19 then del_lin()  --^y
    elsif zz=#0C then line()     --^l
    elsif zz=#02 then block()    --^l
    elsif zz=#06 then files()    --^l
    elsif zz=#13 then strings()  --^l
    elsif zz=#03 then edabort()  --^c
    elsif zz=#1B then edabort()  --esc
    end if
    end while
--end main
