--klrlfn.e
--long filename routines for Euphoria Dos32 in dosboxes under Windows9X

--globals:

--function  lfnfindfirst(filespec)  --returns { longname (or ""), attrib }
--function  lfnfindnext()           --returns { longname (or ""), attrib }
--procedure lfnfindclose()
--function  lfnshortpath(longname)  --returns shortpath (or "")
--function  lfnlongpath(shortname)  --returns longpath (or "")
--function  lfnopen(name, mode)     --returns filenumber (or -1)
--procedure lfnrename(oldname, newname)
--function  lfngetcwd()             --returns current working directory
--constant  lfnRDONLY
--constant  lfnHIDDEN
--constant  lfnSYSTEM
--constant  lfnLABEL
--constant  lfnDIREC


include machine.e

constant lfnMAXPATH=260
atom ffblk ffblk=0
integer ffhandle ffhandle=0

global constant lfnRDONLY= #01
global constant lfnHIDDEN= #02
global constant lfnSYSTEM= #04
global constant lfnLABEL=  #08
global constant lfnDIREC=  #10

global function lfnfindfirst(sequence filespec)
  sequence reg, ffname
  integer ffattrib
  atom fspeclow, p
  fspeclow=allocate_low(length(filespec)+1)
  poke(fspeclow,filespec & 0)
  if ffblk=0 then ffblk=allocate_low(320) end if
  reg=repeat(0,10)
  reg[REG_AX]=#714E
  reg[REG_CX]=#00FF
  reg[REG_SI]=#0001
  reg[REG_DS]=floor(fspeclow/16)
  reg[REG_DX]=remainder(fspeclow,16)  --correction provided by Bill Magaletta
  reg[REG_ES]=floor(ffblk/16)
  reg[REG_DI]=remainder(ffblk,16)
  reg=dos_interrupt(#21,reg)
  ffname=""
  if (and_bits(reg[REG_FLAGS],#0001)) then
    ffhandle=0
    ffattrib=0
  else
    ffhandle=reg[REG_AX]
    ffattrib=peek(ffblk+0)
    p=ffblk+44
    while peek(p) do ffname&=peek(p) p+=1 end while
    end if
  free_low(fspeclow)
  return { ffname, ffattrib }
  end function


global function lfnfindnext()
  sequence reg, ffname
  integer ffattrib
  atom p
  ffname=""
  ffattrib=0
  if (ffblk and ffhandle) then
    reg=repeat(0,10)
    reg[REG_AX]=#714F
    reg[REG_BX]=ffhandle
    reg[REG_SI]=#0001
    reg[REG_ES]=floor(ffblk/16)
    reg[REG_DI]=remainder(ffblk,16)
    reg=dos_interrupt(#21,reg)
    if not and_bits(reg[REG_FLAGS],#0001) then
      ffattrib=peek(ffblk+0)
      p=ffblk+44
      while peek(p) do ffname&=peek(p) p+=1 end while
      end if
    end if
  return { ffname, ffattrib }
  end function

global procedure lfnfindclose()
  sequence reg
  if ffhandle then
    reg=repeat(0,10)
    reg[REG_AX]=#71A1
    reg[REG_BX]=ffhandle
    reg=dos_interrupt(#21,reg)
    ffhandle=0
    end if
  if ffblk then
    free_low(ffblk)
    ffblk=0
    end if
  end procedure

global function lfnshortpath(sequence longname)
  sequence reg, spath
  atom lnamelow, spathlow, p
  lnamelow=allocate_low(length(longname)+1)
  poke(lnamelow,longname&0)
  spathlow=allocate_low(lfnMAXPATH)
  poke(spathlow,0)
  spath=""
  reg=repeat(0,10)
  reg[REG_AX]=#7160
  reg[REG_CX]=#0001
  reg[REG_DS]=floor(lnamelow/16)
  reg[REG_SI]=remainder(lnamelow,16)
  reg[REG_ES]=floor(spathlow/16)
  reg[REG_DI]=remainder(spathlow,16)
  reg=dos_interrupt(#21,reg)
  p=spathlow
  while peek(p) do spath&=peek(p) p+=1 end while
  free_low(lnamelow)
  free_low(spathlow)
  return spath
  end function


global function lfnlongpath(sequence shortname)
  sequence reg, lpath
  atom snamelow, lpathlow, p
  snamelow=allocate_low(length(shortname)+1)
  poke(snamelow,shortname&0)
  lpathlow=allocate_low(lfnMAXPATH)
  poke(lpathlow,0)
  lpath=""
  reg=repeat(0,10)
  reg[REG_AX]=#7160
  reg[REG_CX]=#0002
  reg[REG_DS]=floor(snamelow/16)
  reg[REG_SI]=remainder(snamelow,16)
  reg[REG_ES]=floor(lpathlow/16)
  reg[REG_DI]=remainder(lpathlow,16)
  reg=dos_interrupt(#21,reg)
  p=lpathlow
  while peek(p) do lpath&=peek(p) p+=1 end while
  free_low(snamelow)
  free_low(lpathlow)
  return lpath
  end function

global function lfnopen(sequence name, sequence mode)
  atom namelow
  sequence spath, reg
  namelow=allocate_low(length(name)+1)
  poke(namelow,name&0)
  reg=repeat(0,10)
  --If mode is "w.." or "a..", create a file with the long name.
  --Do nothing if the file already exists.
  if((mode[1]='w') or (mode[1]='a')) then
    reg[REG_AX]=#716C
    reg[REG_BX]=#0001  --mode "write"
    reg[REG_CX]=#0000  --attribute "normal"
    reg[REG_DX]=#0010  --create, fail if it already exists
    reg[REG_DI]=#0001  --curly hint
    reg[REG_DS]=floor(namelow/16)
    reg[REG_SI]=remainder(namelow,16)
    reg=dos_interrupt(#21,reg)
    if not (reg[REG_FLAGS]and 1) then  --ok, now close it
      reg[REG_BX]=reg[REG_AX]
      reg[REG_AX]=#3E00
      reg=dos_interrupt(#21,reg)
      end if
    end if
  free_low(namelow)
  spath=lfnshortpath(name)  --find its short name
  if length(spath)=0 then return -1 end if  --no such file
  return open(spath,mode)   --open safely using the short name
  end function

global procedure lfnrename(sequence oldname, sequence newname)
  sequence reg
  atom onamelow, nnamelow, p
  onamelow=allocate_low(length(oldname)+1)
  nnamelow=allocate_low(length(newname)+1)
  reg=repeat(0,10)
  reg[REG_AX]=#7156
  reg[REG_DS]=floor(onamelow/16)
  reg[REG_DX]=remainder(onamelow,16)
  reg[REG_ES]=floor(nnamelow/16)
  reg[REG_DI]=remainder(nnamelow,16)
  reg=dos_interrupt(#21,reg)
  if (reg[REG_FLAGS] and 1) then newname=oldname  --failure
  else
    newname=""
    p=nnamelow
    while peek(p) do newname&=peek(p) p+=1 end while
    end if
  free_low(onamelow)
  free_low(nnamelow)
  end procedure

global function lfngetcwd()
  sequence reg, cwd
  atom cwdlow, p
  cwdlow=allocate_low(lfnMAXPATH)
  reg=repeat(0,10)
  reg[REG_AX]=#7147
  reg[REG_DX]=#0000
  reg[REG_DS]=floor(cwdlow/16)
  reg[REG_SI]=remainder(cwdlow,16)
  reg=dos_interrupt(#21,reg)
  cwd=""
  if not and_bits(reg[REG_FLAGS],1) then
    cwd&='\\'
    p=cwdlow
    while peek(p) do cwd&=peek(p) p+=1 end while
    end if
  free_low(cwdlow)
  return cwd
  end function
