--sd.ex

include klrlfn.e

constant help="usage:  sd path   --shows subdirs (up to 14 chars), if any"

sequence stack stack={}

function lowcase(sequence x)
  return x+(x>='A' and x<='Z')*32
  end function

function stricmp(sequence a, sequence b)
  sequence ta, tb
  ta=lowcase(a)
  tb=lowcase(b)
  return compare(ta,tb)
  end function

procedure sortstack(integer n1, integer n2)
  integer i
  sequence t
  for j=(n1+1) to n2 do
    t=stack[j]
    i=j-1
    while (i>=n1) and (stricmp(stack[i],t)>0) do
      stack[i+1]=stack[i]
      i -= 1
      end while
    stack[i+1]=t
    end for
  end procedure

--main
  integer n
  sequence path, cmd, found
  cmd=command_line()
  if length(cmd)<3 then
    path=lfngetcwd()
  else
    n=match("/?",cmd[3])
    if n then printf(1,"%s\n",{help}) abort(0) end if
    path=cmd[3]
    end if
  n=match("*",path)
  if not n then
    if path[length(path)]!='\\' then path&="\\" end if
    path&="*.*"
    end if
  found=lfnfindfirst(path)
  while length(found[1]) do
    if and_bits(found[2],lfnDIREC) and not
      and_bits(found[2],lfnHIDDEN) and not
      (found[1][1]='.') then
      if length(found[1])>14 then found[1]=found[1][1..14] end if
      stack=append(stack,found[1])
      end if
    found=lfnfindnext()
    end while
  lfnfindclose()
  n=length(stack)
  if  n=0 then abort(0) end if
  sortstack(1,n)
  for i=1 to n do
    if (i and remainder(i,5)=1) then printf(1,"\n",{}) end if
    printf(1,"%-15s",{stack[i]})
    end for
  --end main
