--typ.ex
--K.L. Roger
--readonly subset of ed.ex
--replaces tabs with spaces, divides lines longer than maxcols
--this version for Euphoria 2.0 dos32

include conio.e
include klrlfn.e

constant
  maxlines=15000,
  screenrows=25,
  screencols=80,
  tabs=4,
  maxcols=screencols-1,
  page=screenrows-1,
  true=1,
  false=0,
  nonolist={".exe",".com",".dll",".sys",".lib",".zip"}

sequence
  doc, cmdline, curline, fname, srchstr,
  str0, str1, str2

integer
  frow, srow, nrowf, lenss, searchcol,
  blkbeg, blkend,
  incok, savok, cpyok, indtog,
  zz, f1

constant hlp={
  " UArr   cursor up one line",
  " DArr   cursor down one line",
  " Home   cursor to top of page",
  " End    cursor to bottom of page",
  "^Home   to beginning of file",
  "^End    to end of file",
  " PgUp   up 20 lines",
  " PgDn   down 20 lines",
  " Esc    quit --also ^q, ^e, and ^c",
  "^ll     locate line, will query for line number",
  "^ss     search for string, will query for the string",
  "^sa     search again for the same string",
  "^bb     mark block beginning",
  "^be     mark block ending",
  "^bs     save block to a file, will query for a filename" }

function lower(object x)
  return x+(x>='A' and x<='Z')*#20
  end function

--prep
cmdline=command_line()
if length(cmdline)<3 then
  puts(1,"usage:  ex typ filename   --text reader, F1 is the help key\n")
  abort(0)
  end if
fname=cmdline[3]
zz=length(fname)
if zz>3 then
  for i=1 to length(nonolist) do
    if compare(lower(fname[zz-3..zz]),nonolist[i])=0 then
      printf(1,"can't read %s files\n",{nonolist[i]})
      abort(0)
      end if
    end for
  end if
--end prep

procedure str2doc(sequence s, integer row)
  --copy string s to doc[row]
  --delete trailing spaces
  integer n
  n=length(s)
  for i=n to 1 by (-1) do
    if s[i]=' ' then n=n-1 else exit end if
    end for
  if n then s=s[1..n] else s="" end if
  doc[row]=s
  end procedure

procedure nuldoc(integer row)
  doc[row]=""
  end procedure

procedure set_init()
  blkbeg=0
  blkend=0
  doc={}
  nrowf=0
  frow=0
  curline=""
  srchstr=""
  lenss=0
  clrscr()
  srow=1
  end procedure

procedure nul_lin()
  gotoxy(1,srow)
  clreol()
  end procedure

function querystr(sequence qs)
  sequence as
  nul_lin()
  as=query(qs)
  nul_lin()
  puts(1,curline)
  gotoxy(1,srow)
  return as
  end function

function querychar(sequence qs)
  integer ac, ax
  nul_lin()
  puts(1,qs&" ? ")
  gotoxy(length(qs)+4,srow)
  ac=getch()
  if ac=0 then ax=getch() end if
  nul_lin()
  puts(1,curline)
  gotoxy(1,srow)
  return ac
  end function

procedure wrt_pag(integer r1)
  integer j
  clrscr()
  j=r1
  for i=1 to screenrows do
    if j>nrowf then exit end if
    gotoxy(1,i)
    str0=doc[j]
    puts(1,str0)
    j=j+1
    end for
  end procedure

procedure inc_nrow()
  if nrowf=maxlines then
    incok=false
    zz=querychar(sprintf("%d line limit reached, ok",{maxlines}))
  else
    incok=true
    nrowf=nrowf+1
    doc=append(doc,"")
    end if
  end procedure

procedure uh_oh(sequence name)
  zz=querychar(sprintf("cannot write file %s, ok",{name}))
  nul_lin()
  puts(1,curline)
  gotoxy(1,srow)
  savok=false
  end procedure

procedure doexit()
  restore_screen()
  abort(0)
  end procedure

procedure crs_up()
  if frow=1 then return end if
  srow=srow-1
  frow=frow-1
  curline=doc[frow]
  if srow=0 then
    srow=1
    gotoxy(1,1)
    insline()
    puts(1,curline)
    end if
  gotoxy(1,srow)
  end procedure

procedure crs_dwn()
  if frow=nrowf then
    inc_nrow()
    if not incok then return end if
    end if
  srow=srow+1
  frow=frow+1
  curline=doc[frow]
  if srow>screenrows then
    puts(1,"\n")  --???
    gotoxy(1,screenrows)
    puts(1,curline)
    srow=screenrows
    end if
  gotoxy(1,srow)
  end procedure

procedure get_fil(integer f)
  integer  n, k, m, cc, insert
  sequence cstr
  object tstr
  if nrowf=0 then insert=0 else insert=1 end if
  while true do
    tstr=gets(f)
    if atom(tstr) then exit end if --eof
    --remove '\n'
    n=length(tstr)
    if n then
      if tstr[n]='\n' then
        n=n-1
        tstr=tstr[1..n]
        end if
      end if
    --expand tabs
    k=0
    cstr=""
    for i=1 to n do
      cc=tstr[i]
      if cc='\t' then
        m=tabs-remainder(k,tabs)
        if m then
          for j=1 to m do cstr=cstr&' ' k=k+1 end for
          end if
        else cstr=cstr&cc k=k+1
        end if
      end for
    n=k
    --chop long lines to maxcols
    while true do
      inc_nrow()
      if not incok then return end if
      if insert then
        for j=nrowf to (frow+1) by (-1) do doc[j]=doc[j-1] end for
        end if
      if not insert then frow=frow+1 end if
      if n>maxcols then
        doc[frow]=cstr[1..maxcols]
        cstr=cstr[(maxcols+1)..n]
        else doc[frow]=cstr
        end if
      n=n-maxcols
      if insert then frow=frow+1 end if
      if n<=0 then exit end if
      end while
    end while
  end procedure

procedure put_fil(integer f, integer r1, integer r2)
  for i=r1 to r2 do puts(f,doc[i]&'\n') end for
  end procedure

procedure read_fil()
  f1=lfnopen(fname,"r")
  if f1>0 then get_fil(f1) close(f1) end if
  if nrowf=0 then nrowf=1 doc=append(doc,"") end if
  frow=1
  srow=1
  curline=doc[1]
  wrt_pag(1)
  gotoxy(1,1)
  end procedure

procedure doopen()
  save_screen()
  set_init()
  read_fil()
  end procedure

procedure loc_lin()
  sequence s1
  integer n, k
  object r
  s1=querystr("line number")
  if length(s1)=0 then return end if
  r=atoi(s1)
  if integer(r) then n=r else return end if
  if (n<1) or (n>nrowf) then return end if
  k=n-12
  if k<1 then k=1 end if
  frow=n
  srow=frow-k+1
  wrt_pag(k)
  curline=doc[frow]
  gotoxy(1,srow)
  end procedure

procedure loc_str()
  integer i, j, k, n
  if lenss=0 then return end if
  n=length(curline)
  if searchcol>=n then str2="" else str2=curline[(searchcol+1)..n] end if
  j=match(srchstr,lower(str2))
  if j then j=j+searchcol end if
  i=frow
  while (i<nrowf) and (j=0) do
    i=i+1
    str2=doc[i]
    j=match(srchstr,lower(str2))
    end while
  k=i-12
  if k<1 then k=1 end if
  frow=i
  srow=frow-k+1
  wrt_pag(k)
  curline=doc[frow]
  if j>0 then
    gotoxy(j,srow)
    searchcol=j
   else
    gotoxy(1,srow)
    end if
  end procedure

procedure set_str()
  srchstr=lower(querystr("string to locate"))
  lenss=length(srchstr)
  if lenss=0 then return end if
  searchcol=0
  loc_str()
  end procedure

procedure crs_top()
  frow=frow-srow+1
  srow=1
  gotoxy(1,srow)
  curline=doc[frow]
  end procedure

procedure crs_bot()
  integer j
  j=frow
  frow=frow+screenrows-srow
  if(frow>nrowf) then frow=nrowf end if
  srow=srow+frow-j
  gotoxy(1,srow)
  curline=doc[frow]
  end procedure

procedure page_up()
  integer k
  k=frow+1-srow-page
  if k<1 then k=1 end if
  wrt_pag(k)
  srow=frow+1-k
  if srow>screenrows then srow=screenrows end if
  frow=k+srow-1
  curline=doc[frow]
  gotoxy(1,srow)
  end procedure

procedure page_dwn()
  integer k
  k=frow+1-srow+page
  if k>(nrowf-4) then k=nrowf-4 end if
  if k<1 then k=1 end if
  wrt_pag(k)
  srow=frow+1-k
  if srow<1 then srow=1 end if
  frow=k+srow-1
  curline=doc[frow]
  gotoxy(1,srow)
  end procedure

procedure crs_tof()
  frow=1
  srow=1
  wrt_pag(1)
  curline=doc[frow]
  gotoxy(1,srow)
  end procedure

procedure crs_eof()
  integer i
  if nrowf<=screenrows then i=1 srow=nrowf
    else i=nrowf-12 srow=13
    end if
  wrt_pag(i)
  frow=nrowf
  curline=doc[frow]
  gotoxy(1,srow)
  end procedure

procedure mrk_beg()
  blkbeg=frow
  end procedure

procedure mrk_end()
  blkend=frow
  end procedure

procedure sav_blk()
  integer same, f
  if (blkbeg=0) or (blkend=0) or (blkend<blkbeg) then return end if
  str2=querystr("filename")
  if length(str2)=0 then return end if
  if compare(lower(str2),lower(fname))=0 then
    same=true
    else same=false
    end if
  if(same) then
    uh_oh(str2)
    else
    f=lfnopen(str2,"w")
    if f<=0 then
      uh_oh(str2)
      else
      put_fil(f,blkbeg,blkend)
      close(f)
      end if
    end if
  end procedure

procedure help()
  clrscr()
  printf(1,"line %d of %d,  file:  %s\n\n",{frow,nrowf,fname})
  for i=1 to 15 do
    printf(1,"%s\n",{hlp[i]})
    end for
  zz=getch() if zz=0 then zz=getch() end if
  wrt_pag(frow-srow+1)
  gotoxy(1,srow)
  end procedure

procedure block()
  zz=getch()
  if zz=#02 then mrk_beg()     --^bb
  elsif zz=#05 then mrk_end()  --^be
  elsif zz=#13 then sav_blk()  --^bs
  end if
  end procedure

procedure files()
  zz=getch()
  if zz=#11 then doexit()        --^fq
  elsif zz=#05 then doexit()     --^fe
  end if
  end procedure

procedure cursor()
  zz=getch()
  if zz=#48 then crs_up()      --UArr
  elsif zz=#50 then crs_dwn()  --DArr
  elsif zz=#47 then crs_top()  --home
  elsif zz=#4F then crs_bot()  --end
  elsif zz=#77 then crs_tof()  --^home
  elsif zz=#75 then crs_eof()  --^end
  elsif zz=#49 then page_up()  --PgUp
  elsif zz=#51 then page_dwn() --PgDn
  elsif zz=#3B then help()     --F1
  end if
  searchcol=0
  end procedure

procedure line()
  zz=getch()
  if zz=#0C then loc_lin()     --^ll
  end if
  end procedure

procedure strings()
  zz=getch()
  if zz=#13 then set_str()    --^ss
  elsif zz=#01 then loc_str() --^sa
  end if
  end procedure

--main
  doopen()
  while(true) do
    zz=getch()
    if zz=#00 then cursor()
    elsif zz=#0C then line()     --^l
    elsif zz=#02 then block()    --^l
    elsif zz=#06 then files()    --^l
    elsif zz=#13 then strings()  --^l
    elsif zz=#03 then doexit()   --^c
    elsif zz=#1B then doexit()   --Esc
    end if
    end while
--end main
